<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Document</title>
    
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css" integrity="sha384-MCw98/SFnGE8fJT3GXwEOngsV7Zt27NXFoaoApmYm81iuXoPkFOJwJ8ERdknLPMO" crossorigin="anonymous">
    
    
    
    <style>
        body{
            height: 100vh;
            width: 100%;
            background: url('https://i.pinimg.com/originals/9f/1f/68/9f1f68765ddd8bf7f3f4b9345090e6ba.gif');
            background-size: cover;
            background-repeat: no-repeat;
            background-attachment: fixed;
        }
        
        ol li {
            list-style: none;
        }
        ol li a{
            color: #000;
            text-decoration: none;
        }
         ol li a:hover{
            
            background: rgba(0, 0, 0, 0.56);
        } 
        
        code{
            color:#000;
        }
    </style>
</head>
<body>
   <div class="container contenedor-fondo">
       <div class="row">
           <div class="col-md-3">
              <div class="mt-4 bg-warning cont-array">
                  <h4>Array</h4>
                  <ol>
                      <li><a href="#arrayFrom">Array.from()</a></li>
                      <li><a href="#arrayOf">Array.of()</a></li>
                      <li><a href="#arrayPop">Array.pop()</a></li>
                      <li><a href="#arraySort">Array.sort()</a></li>
                      <li><a href="#arrayJoin">Array.join()</a></li>
                  </ol>
              </div>
              
              <div class="bg-success">
                  <h4>String</h4>
                  <ol>
                      <li><a href="#string-charAt">String.charAt()</a></li>
                      <li><a href="#string-concat">String.concat()</a></li>
                      <li><a href="#string-includes">String.includes()</a></li>
                      <li><a href="#string-substring">String.substring()</a></li>
                      <li><a href="#string-fromCharCode">String.fromCharCode()</a></li>
                  </ol>
              </div>
              
              <div>
                  <h4>Object</h4>
                  <ol>
                      <li><a href="#object-create">Object.create()</a></li>
                      <li><a href="#object-is">Object.is()</a></li>
                      <li><a href="#object-assign">Object.assign()</a></li>
                      <li><a href="#object-entries">Object.entries()</a></li>
                      <li><a href="#object-defineproperties">Object.defineProperties()</a></li>
                      
                  </ol>
              </div>
              
              <div>
                  <h4>Boolean</h4>
                  <ol>
                      <li><a href="#boolean-toSource">Boolean.toSource()</a></li>
                     
                  </ol>
              </div>
               
              <div>
                  <h4>Num. Integros</h4>
                  <ol>
                      <li>
                          <a href="#"></a>
                      </li>
                      
                  </ol>
              </div> 
              
              <div>
                  <h4>Date</h4>
                  <ol>
                      <li>
                          <a href="#"></a>
                      </li>
                      
                  </ol>
              </div>  
           </div>
           
           <!--  Seccion derecha -->
           <div class="col-md-9 ">
               <div class="mt-4 bg-warning px-4 pt-3">
                   <!------  ARRAYS  ------>
                    <div>
                        <h1>Arrays</h1>
                        <p>
                            El objeto Array de JavaScript es un objeto global que es usado en la construcción de arrays, que son objetos tipo lista de alto nivel.
                        </p>
                        <h4>Crear un Array</h4>
                        <p>
                            <code>
                                var frutas = ['Manzana', 'Banana']; <br>
                                console.log(frutas.length); 
                                // 2
                            </code>
                        </p>
                    </div>
                    <div id="arrayFrom">
                        <h4>Array.from()</h4>
                        <p>
                            <code>
                                El método Array.from() crea una nueva instancia de Array a partir de un objeto iterable.
                            </code>
                        </p>
                        <code>
                            frutas.forEach(function (elemento, indice, array) {<br>
                                console.log(elemento, indice);<br>
                            });<br>
                            // Manzana 0 <br>
                            // Banana 1 <br>
                        </code>
                    </div>
                    <hr>
                    <div id="arrayOf">
                        <h4>Array.of()</h4>
                        <p>
                            <code>
                                El método Array.of() crea una nueva instancia Array con un número variable de elementos pasados como argumento, independientemente del número o del tipo.
                                <br>
                                La diferencia entre Array.of() y el constructor Array reside en como maneja los parámetros de tipo entero: Array.of(7) crea un array con un solo elemento, 7, mientras que Array(7) crea un array vacío con una propiedad length de 7 (Nota: esto implica un array de 7 ranuras vacías, no ranuras con valores undefined).
                            </code>
                        </p>
                        <code>
                            Array.of(7);       // [7] <br>
                            Array.of(1, 2, 3); // [1, 2, 3] <br><br>

                            Array(7);          // [ , , , , , , ] <br>
                            Array(1, 2, 3);    // [1, 2, 3] <br>
                        </code>
                    </div>
                    <hr>
                    <div id="arrayPop">
                        <h4>Array.pop()</h4>
                        <p>
                            <code>
                               El método pop() elimina el último elemento de un array y lo devuelve. Este método cambia la longitud del array.
                            </code>
                        </p>
                        <code>
                            var myFish = ['angel', 'clown', 'mandarin', 'sturgeon']; <br>
                            console.log(myFish); // ['angel', 'clown', 'mandarin', 'sturgeon']
                            <br>
                            var popped = myFish.pop();
                            <br>
                                                    console.log(myFish); // ['angel', 'clown', 'mandarin' ] 
                            <br>
                            console.log(popped); // 'sturgeon'
                        </code>
                    </div>
                    <hr>
                    <div id="arraySort">
                        <h4>Array.prototype.sort()</h4>
                        <p>
                            <code>
                               El método sort() ordena los elementos de un array localmente y devuelve el array. La ordenación no es necesariamente estable. El modo de ordenación por defecto responde a la posición del valor del string de acuerdo a su valor
                            </code>
                        </p>
                        <code>
                            var arr = [ 'a', 'b', 'Z', 'Aa', 'AA' ]; <br>
                            arr.sort();  //[ 'AA', 'Aa', 'Z', 'a', 'b' ]
                            <br><br>
                            var arr = [ 40, 1, 5, 200 ];<br>
                            function comparar ( a, b ){ return a - b; } <br>
                            arr.sort( comparar );  // [ 1, 5, 40, 200 ] <br>
                        </code>
                    </div>
                    <hr>
                    <div id="arrayJoin">
                        <h4>Array.prototype.join()</h4>
                        <p>
                            <code>
                                El método join() une todos los elementos de una matriz (o un objeto similar a una matriz) en una cadena y devuelve esta cadena.
                                <br><br>
                                El siguiente ejemplo crea un arreglo a con tres elementos para luego unir el arreglo cuatro veces: usando el separador predeterminado, luego una coma y un espacio, luego un signo de suma, y finalmente una cadena vacío.
                            </code>
                        </p>
                        <code>
                            var a = ['Viento', 'Lluvia', 'Fuego']; <br>
                            var miVar1 = a.join();      // asigna 'Viento,Lluvia,Fuego' a miVar1 <br>
                            var miVar2 = a.join(', ');  // asigna 'Viento, Lluvia, Fuego' a miVar2 <br>
                            var miVar3 = a.join(' + '); // asigna 'Viento + Lluvia + Fuego' a miVar3 <br>
                            var miVar4 = a.join('');    // asigna 'VientoLluviaFuego' a miVar4 <br>
                        </code>
                    </div>
                </div>
                
                
                
                <!------  Strings  ----->
                <div class="mt-5 bg-success">
                    <div>
                        <h1>Strings</h1>
                        <p>
                            Una cadena de JavaScript almacena una serie de caracteres como "John Doe". <br>
                            Una cadena puede ser cualquier texto dentro de comillas dobles o simples:
                        </p>
                        <code>
                            var carname = "Volvo XC60";<br>
                            var carname = 'Volvo XC60';
                        </code>
                    </div>
                    <div id="string-charAt">
                        <h4>String.charAt()</h4>
                        <p>
                            El método charAt() de String devuelve en un nuevo String el carácter UTF-16 de una cadena.    
                            <br>
                            El siguiente ejemplo muestra caracteres de diferentes localizaciones en la cadena "Brave new world":
                        </p>
                        <code>
                           
                            var cualquierCadena="Brave new world";<br>

                            console.log("El carácter en el índice 0 es '" + cualquierCadena.charAt(0) + "'") <br>
                            console.log("El carácter en el índice 1 es '" + cualquierCadena.charAt(1) + "'")
                            <br>
                            console.log("El carácter en el índice 2 es '" + cualquierCadena.charAt(2) + "'")
                            <br>
                            console.log("El carácter en el índice 3 es '" + cualquierCadena.charAt(3) + "'")
                            <br>
                            console.log("El carácter en el índice 4 es '" + cualquierCadena.charAt(4) + "'")
                            <br>
                            console.log("El carácter en el índice 999 es '" + cualquierCadena.charAt(999) + "'")
                        </code>
                        <br><br>
                        Estas líneas muestran lo siguiente:
                        <br><br>
                        El carácter en el índice 0 es 'B'<br>
                        El carácter en el índice 1 es 'r'<br>
                        El carácter en el índice 2 es 'a'<br>                            
                        El carácter en el índice 3 es 'v'<br>
                        El carácter en el índice 4 es 'e'<br>
                        El carácter en el índice 999 es ''<br>
                            
                        
                    </div>
                    <hr>
                    <div id="string-concat">
                        <h4>string.concat()</h4>
                        <p>
                            El método concat() se utiliza para combinar dos o más cadenas. Este método no cambia las cadenas existentes, sino que retorna una nueva cadena.
                        </p>
                        <p>
                            Concat crea una nueva cadena concatenando la cadena que invoca al método con el resto de cadenas pasadas como parámetro, ninguna de las cadenas originales se ve afectada.
                        </p>
                        <p>
                            El siguiente ejemplo combina cadenas en una nueva cadena.
                            <br>
                            <br>
                            cadena1="Oh "<br>
                            cadena2="qué maravillosa "<br>
                            cadena3="mañana'."<br>
                            cadena4=cadena1.concat(cadena2,cadena3) // devuelve "Oh qué maravillosa mañana'."<br>
                        </p>

                    </div>
                    <hr>
                    <div id="string-includes">
                        <h4>String.includes()</h4>
                        <p>
                            El método <strong>includes()</strong> determina si una cadena de texto puede ser encontrada dentro de otra cadena de texto, retornando <strong>true</strong> o <strong>false</strong> según corresponda.
                        </p>
                        <p>
                            El método includes() es "case sensitive" (tiene en cuenta mayúsculas y minúsculas). Por ejemplo, la siguiente expresión devolverá <strong>false</strong>:
                        </p>
                        <code>
                            'Ballena azul'.includes('ballena'); // devuelve false
                        </code>
                        <p>
                            El siguiente ejemplo se detalla de mejor manera el uso del include()
                        </p>
                        <code>
                            var str = 'To be, or not to be, that is the question.';<br><br>

                            console.log(str.includes('To be'));       // true<br>
                            console.log(str.includes('question'));    // true<br>
                            console.log(str.includes('nonexistent')); // false<br>
                            console.log(str.includes('To be', 1));    // false<br>
                            console.log(str.includes('TO BE'));       // false<br>
                        </code>
                    </div>
                    <hr>
                    <div id="string-substring">
                        <h4>string.substring()</h4>
                        <p>
                            El <strong>substring()</strong> método devuelve la parte de los string índices de inicio y fin, o al final de la cadena.
                        </p>
                        <code>
                            var str = 'Mozilla';<br>

                            console.log(str.substring(1, 3));<br>
                            // expected output: "oz"<br><br>

                            console.log(str.substring(2));<br>
                            // expected output: "zilla"<br>
                        </code>
                        <p>
                            El siguiente ejemplo se usa substring()para mostrar los caracteres de la cadena 'Mozilla':
                        </p>
                        <code>
                            var anyString = 'Mozilla';<br><br>

                            // Displays 'M' <br>
                            console.log(anyString.substring(0, 1));<br>
                            console.log(anyString.substring(1, 0));<br><br>

                            // Displays 'Mozill'<br>
                            console.log(anyString.substring(0, 6));<br><br>

                            // Displays 'lla'<br>
                            console.log(anyString.substring(4));<br>
                            console.log(anyString.substring(4, 7));<br>
                            console.log(anyString.substring(7, 4));<br><br>

                            // Displays 'Mozilla'<br>
                            console.log(anyString.substring(0, 7));<br>
                            console.log(anyString.substring(0, 10));<br>
                        </code>
                        <br>
                        <h4>Usando el metodo substring() con la propiedad length</h4>
                        
                        <p>
                            El siguiente ejemplo utiliza el método substring()  y la lengthpropiedad para extraer los últimos caracteres de una cadena en particular. Este método puede ser más fácil de recordar, dado que no necesita conocer los índices de inicio y finalización como lo haría en los ejemplos anteriores. 
                        </p>
                        <code>
                            // Displays 'illa' the last 4 characters <br>
                            var anyString = 'Mozilla';<br>
                            var anyString4 = anyString.substring(anyString.length - 4);<br>
                            console.log(anyString4);<br><br>

                            // Displays 'zilla' the last 5 characters<br>
                            var anyString = 'Mozilla';<br>
                            var anyString5 = anyString.substring(anyString.length - 5);<br>
                            console.log(anyString5);<br>
                        </code>
                    </div>
                    <hr>
                    <div id="string-fromCharCode">
                        <h4>string.fromCharCode()</h4>
                        <p>
                            El metodo String.fromCharCode() estático que devuelve una cadena creada mediante el uso de una secuencia de valores Unicode especificada.
                        </p>
                        <p>
                            Este método devuelve una cadena y no un objeto String.
                        </p>
                        <p>                            
                            Debido a que fromCharCode es un método estático de String, usted siempre lo usará como String.fromCharCode(), en vez de un método de un objeto String creado por usted.
                        </p>
                        <p>
                            El siguiene ejemplo devuelve la cadena "ABC".
                        </p>
                        <code>
                            String.fromCharCode(65,66,67)
                        </code>
                    </div>
                </div>
                
                
                <!--Object-->
                <div class="mt-5 bg-success">
                    <div id="">
                        <h4>Object</h4>
                        <p>
                            El constructor Object crea una envoltura de objeto para el valor dado. Si el valor es nullo undefined, creará y devolverá un objeto vacío, de lo contrario, devolverá un objeto de un Tipo que corresponde al valor dado. Si el valor ya es un objeto, devolverá el valor.
                        </p>
                        <p>
                            Cuando se llama en un contexto no-constructor, se Objectcomporta de forma idéntica a new Object().
                        </p>
                        
                        
                    </div>
                    
                    <div id="object-create">
                        <h4>Object.create()</h4>
                        <p>
                            El método Object.create() crea un nuevo objeto con el objeto y propiedades del prototipo especificado.
                        </p>
                        <p>
                            Si se especifica y no es undefined, un objeto cuyas propiedades enumerables propias (es decir, aquellas propiedades definidas sobre si mismo y no son propiedades enumerable a lo largo de su cadena de prototipos) espefica descriptores de propiedad para ser agregadas al objeto recien creado, con los nombres de propiedad correspondiente. Estas propiedades corresponden al segundo argumento de  Object.defineProperties.
                        </p>
                        <p>
                            Lanza una excepción TypeError si el parámetro proto no es null o un objeto.
                        </p>
                        <p>
                            Debajo esta un ejemplo de como usar Object.create para lograr herencia clásica. Esta es para herencía simple, la cual es todo lo que soporta JavaScript.
                        </p>
                        <code>
                            // Shape - superclase <br>
                            function Shape() { <br>
                              this.x = 0;<br>
                              this.y = 0;<br>
                            }<br><br>

                            // método de la superclase<br>
                            Shape.prototype.move = function(x, y) {<br>
                                this.x += x;<br>
                                this.y += y;<br>
                                console.info("Shape moved.");<br>
                            };<br><br>

                            // Rectangle - subclase<br>
                            function Rectangle() {<br>
                              Shape.call(this); // llama al contructor de la superclase.<br>
                            }<br><br>

                            // subclase extiende superclase<br>
                            Rectangle.prototype = Object.create(Shape.prototype);<br>
                            Rectangle.prototype.constructor = Rectangle;<br><br>

                            var rect = new Rectangle();<br><br>

                            rect instanceof Rectangle // true.<br>
                            rect instanceof Shape // true.<br><br>

                            rect.move(1, 1); // Salida, "Shape moved."<br>
                        </code>
                    </div>
                    <hr>
                    <div id="object-is">
                        <h4>Object.is()</h4>
                        <p>
                            El método Object.is() determina si dos valores son iguales. Dos valores son iguales si se puede asegurar que: <br>
                            
                            <ul>
                                <li>ambos son undefined</li>
                                <li>ambos son null</li>
                                <li>ambos son true o false</li>
                                <li>ambos son strings y tienen la misma longitud con los mismos caracteres</li>
                                <li>ambos son el mismo objeto</li>
                                <li>ambos son numeros y
                                    <ul>
                                        <li>ambos +0 (mayores que 0)</li>
                                        <li>ambos -0 (menores que 0)</li>
                                        <li>ambos son NaN</li>
                                        <li>o ambos no son cero o no son de tipo NaN y tienen el mismo valor</li>
                                    </ul>                                
                                </li>
                            </ul>
                        </p>
                        <p>
                            Esta comparación no es igual a la que realiza el operador ==. El operador == aplica varias coerciones(comprobaciones) en ambos sentidos (si no tienen el mismo Type) antes de probar la igualdad (lo que resulta en comportamientos como  "" == false siendo true), pero Object.is no obliga a niguno de los valores.
                        </p>
                        <p>
                            Esta tampoco es igual a la que realiza el operador ===. El operador === (y el operador ==) trata los valores -0 y +0 como iguales, y además, trata Number.NaN como no igual a NaN.
                        </p>
                        
                        <code>
                            Object.is('foo', 'foo');     // true <br>
                            Object.is(window, window);   // true <br><br>

                            Object.is('foo', 'bar');     // false <br>
                            Object.is([], []);           // false<br><br>

                            var test = { a: 1 };<br>
                            Object.is(test, test);       // true<br><br>

                            Object.is(null, null);       // true<br><br>

                            // Special Cases<br>
                            Object.is(0, -0);            // false<br>
                            Object.is(-0, -0);           // true<br>
                            Object.is(NaN, 0/0);         // true<br><br>
                        </code>
                    </div>
                    <hr>
                    <div id="object-assign">
                        <h4>Object.assign()</h4>
                        <p>
                            El método <strong>Object.assign()</strong> se utiliza para copiar los valores de todas la propiedades enumerables de uno o más objetos fuente a un objeto destino. Retorna el objeto destino. 
                        </p>
                        <p><strong>sintaxis</strong> <br>
                            <em>Object.assign(objetivo, ...fuentes)</em>
                            <br><br>
                            <strong>objetivo:</strong>El objeto destino. <br>
                                <strong>fuentes</strong>:Los objetos origen.
                        </p>
                        
                        <p>
                            El método Object.assign() copia sólo las propiedades enumerables y propias del objeto origen a un objeto destino. Usa [[Get]] en la origen y [[Set]] en el destino, por lo que invocará los métodos de acceso y establecimiento (getters y setters). Por consiguiente asignará propiedades frente a sólo copiar o definir propiedades nuevas. Esto puede hacer que sea inadecuado para fusionar propiedades nuevas en un prototipo si los objetos fuente contienen métodos de acceso (getters). Para copiar definiciones de propiedades en prototipos, incluyendo su enumerabilidad, se deben usar Object.getOwnPropertyDescriptor() y Object.defineProperty(). <br><br>
                            Tanto las propiedades String como Symbol son copiadas. <br><br>

                            En caso de un error, por ejemplo si una propiedad es de solo lectura, se lanza un TypeError, y el objeto destino se mantendrá sin cambios.<br><br>

                            Note que Object.assign() no lanza excepciones al encontrar en las fuentes propiedades null o undefined.<br><br>
                        </p>
                        <code>
                            var obj = { a: 1 };<br>
                            var copy = Object.assign({}, obj);<br>
                            console.log(copy); // { a: 1 } <br>
                        </code>
                        <br>
                        <p>
                            Para un clonado profundo, necesitamos usar otra alternativa ya que Object.assign() copia valores de propiedades. Si el valor en la fuente es una referencia a un objeto, solo se copia la referencia en sí, como valor de la propiedad.
                        </p>
                        
                        <code>
                            function test() { <br>
                                'use strict'; <br><br>

                                let obj1 = { a: 0 , b: { c: 0}};<br>
                                let obj2 = Object.assign({}, obj1);<br>
                                console.log(JSON.stringify(obj2)); // { a: 0, b: { c: 0}}<br><br>

                                obj1.a = 1;<br>
                                console.log(JSON.stringify(obj1)); // { a: 1, b: { c: 0}}<br>
                                console.log(JSON.stringify(obj2)); // { a: 0, b: { c: 0}}<br><br>

                                obj2.a = 2;<br>
                                console.log(JSON.stringify(obj1)); // { a: 1, b: { c: 0}}<br>
                                console.log(JSON.stringify(obj2)); // { a: 2, b: { c: 0}}<br><br>

                                obj2.b.c = 3;<br>
                                console.log(JSON.stringify(obj1)); // { a: 1, b: { c: 3}}<br>
                                console.log(JSON.stringify(obj2)); // { a: 2, b: { c: 3}}<br><br>

                                // Deep Clone<br>
                                obj1 = { a: 0 , b: { c: 0}};<br>
                                let obj3 = JSON.parse(JSON.stringify(obj1));<br>
                                obj1.a = 4;<br>
                                obj1.b.c = 4;<br>
                                console.log(JSON.stringify(obj3)); // { a: 0, b: { c: 0}}<br>
                            }<br><br>

                            test();<br>
                        </code>
                    </div>
                    <hr>
                    <div id="object-entries">
                        <h4>Object.entries()</h4>
                        <p>
                            El método Object.entries() devuelve una matriz de pares propios de una propiedad enumerable [key, value] de un objeto dado, en el mismo orden que es proporcionado por for...each (La diferencia es que un bucle for-each enumera las propiedades en la cadena de prototipos).
                        </p>
                        
                        <code>
                            var obj = { foo: 'bar', baz: 42 }; <br>
                            console.log(Object.entries(obj)); // [ ['foo', 'bar'], ['baz', 42] ] <br><br>

                            // array like object<br>
                            var obj = { 0: 'a', 1: 'b', 2: 'c' };<br>
                            console.log(Object.entries(obj)); // [ ['0', 'a'], ['1', 'b'], ['2', 'c'] ]<br><br>

                            // array like object with random key ordering<br>
                            var an_obj = { 100: 'a', 2: 'b', 7: 'c' };<br>
                            console.log(Object.entries(an_obj)); // [ ['2', 'b'], ['7', 'c'], ['100', 'a'] ]<br><br>

                            // getFoo is property which isn't enumerable<br>
                            var my_obj = Object.create({}, { getFoo: { value: function() { return this.foo; } } });<br>
                            my_obj.foo = 'bar';<br>
                            console.log(Object.entries(my_obj)); // [ ['foo', 'bar'] ]<br><br>

                            // non-object argument will be coerced to an object<br>
                            console.log(Object.entries('foo')); // [ ['0', 'f'], ['1', 'o'], ['2', 'o'] ]<br><br>

                            // iterate through key-value gracefully<br>
                            var obj = {a: 5, b: 7, c: 9};<br>
                            for (var [key, value] of Object.entries(obj)) {<br>
                                console.log(key + ' ' + value); // "a 5", "b 7", "c 9"<br>
                            }<br><br>

                            // Or, using array extras<br>
                            Object.entries(obj).forEach(([key, value]) => {<br>
                                console.log(key + ' ' + value); // "a 5", "b 7", "c 9"     <br>
                            });<br><br>
                        </code>
                    </div>
                    <hr>
                    <div id="Object-defineproperties">
                        <h4>Object.defineProperties()</h4>
                        <p>
                            El metodo Object.defineProperties() define nuevas o modifica propiedades existentes directamente en el objeto, retornando el objeto.
                            <br>
                            Object.defineProperties<em>(obj, propiedades)</em>
                            <br><br>
                            <strong>obj</strong>
                            <br>
                            El objeto sobre el cual se crearán o modificaran sus propiedades.
                            <br><br>
                            <strong>propiedades</strong>
                            <br>
                            Un objeto cuyas propiedades enumerables propias consituyen descriptores para las propiedades a ser definidas o modificadas. <br>
                            
                        </p>
                        <p>
                            Cuando se llama en un contexto no-constructor, se Objectcomporta de forma idéntica a new Object().
                        </p>
                        <br>
                        <code>
                            Object.defineProperties(obj, { <br>
                              "property1": {<br>
                                value: true,<br>
                                writable: true<br>
                              },<br>
                              "property2": {<br>
                                value: "Hello",<br>
                                writable: false<br>
                              }<br>
                              // etc. etc.<br>
                            });<br>
                        </code>
                    </div>
                           
               </div>
               
               <!------  Boolean  ----->
                <div class="mt-5 bg-success">
                    <div>
                        <h1>Boolean</h1>
                        <p>
                            El valor inicial del objeto Boolean. El valor es convertido a un valor boolean, si es necesario. Si se omite el valor o es 0, -0, null, false, NaN, undefined, o la cadena vacía (""), el objeto tiene un valor incial de false. Todos los demás valores, incluyendo cualquier objeto o la cadena "false", crea un objeto con el valor inicial de true.
                        </p>
                        <p>
                            No se deben confundir los valores primitivos booleanos true y false con los valores true y false del objeto Boolean.
                        </p>
                        <p>
                            Cualquier objeto cuyo valor no sea undefined o null, incluyendo un objeto Boolean cuyo valor sea false, se evalua como true cuando se pasa a una sentencia condicional. Por ejemplo, la condición de la siguiente sentencia se evalúa como true:
                        </p>
                        <code>
                            x = new Boolean(false); <br>
                            if (x) //the condition is true <br>
                        </code>
                        <p>
                            Este comportamiento no se aplica a los valores primitivos booleanos. Por ejemplo, la condición de la siguiente sentencia se evalúa como false:
                        </p>
                        <code>
                            x = false;<br>
                            if (x) //the condition is false
                        </code>
                        <p>
                            No use un objeto Boolean para convertir un valor no booleano a un valor booleano. En ese caso, utilice Boolean como una función para realizar esta tarea:
                        </p>
                        <code>
                            x = Boolean(expression);     //preferido <br>
                            x = new Boolean(expression); //no usar
                        </code>
                        <p>
                            Si especifica cualquier objeto, incluyendo un objeto Boolean cuyo valor es false, como valor inicial del objeto Boolean, el nuevo objeto Boolean tiene un valor de true.
                        </p>
                        <code>
                            myFalse = new Boolean(false);   // initial value of false <br>
                            g = new Boolean(myFalse);       //initial value of true<br>
                            myString = new String("Hello"); // string object<br>
                            s = new Boolean(myString);      //initial value of true<br>
                        </code>
                    </div>
                    <div id="string-charAt">
                        <h4>String.charAt()</h4>
                            
                        
                    </div>
                </div>
               
               
            </div>
        </div>
    </div>
   
   
    <!--script>
         $(document).ready( function () {
             $.ajax('https://jsonplaceholder.typicode.com/todos')
                .done(function(res){
                    var options = {
                        data: res,
                        columns: [
                            
                        ]
                    }

                    //Datatable
                    $('#myTable').DataTable(options);
                })
                .catch(function(res){

                });

        });
    </script-->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.3/umd/popper.min.js" integrity="sha384-ZMP7rVo3mIykV+2+9J3UJ46jBk0WLaUAdn689aCwoqbBJiSnjAK/l8WvCWPIPm49" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/js/bootstrap.min.js" integrity="sha384-ChfqqxuZUCnJSK3+MXmPNIyE6ZbWh2IMqE241rYiqJxyMiZ6OW/JmZQ5stwEULTy" crossorigin="anonymous"></script>
    
</body>
</html>